/*
  Elliptic curve crypto, used in electronic codebook (ECB) or CBC style.
  
  Dr. Orion Sky Lawlor, lawlor@alaska.edu, 2013-04-03 (Public Domain)
*/
#include <stdio.h>
#include <iostream>
#include "ecc_lib.h"
#include "ecc_lib.cpp" /* for linking easier */

int main(int argc,char *argv[]) {
	int key=1787; // US constitution written.  Also a prime number.
	int mode=0; // 0: ECB.  1:CBC.
	if (argc>1) mode=atoi(argv[1]);
	ECcurve_BitCoin curve;
	ECpoint p=curve.start;
	
	while (1) {
		int c=getchar(); // read next character to encrypt
		if (c==EOF) break; // end of file
		ECpoint cp=p.multiply(c,curve); // multiply curve point by char
		std::cout<<cp.x.mod(key)<<"	"<<cp.y.mod(key)<<"\n";
		if (mode) p=cp; // move point along curve
	}
	return 0;
}

